!*dlex

fptr isfunc_t=(func! c&)
func isnum! c&
return inrange!(asc(c),asc('0'),asc('9')) or c='.' or c='e'
func isalpha! c&
return inrange!(asc(lowcase$(c)),asc('a'),asc('z'))

const pfds$=("flaflbfrafrb")
const pfdv=(#TSUB,#TSUBD,#TSUB or 1,#TSUBD or 1)
enum ltype_t=(LNONE,LNUM,LTOK, LOPER,LPAREN,LDELIM,LEND)
local &lstr$,lpos,ltype\ltype_t,lt2\ltype_t lval,lfval#,lsval$
#TOKSIZE=30
func lext$ isf\isfunc_t
i=0
s$=dup$(' ',#TOKSIZE)
do
s{i++}=lstr{lpos++}
loop while call!(isf lstr{lpos})
s{i}=chr&(0)
return s

proc lex
lt2=ltype:ltype=#LNONE
0
case select lstr{lpos}
case ' ':
 inc lpos
 goto 0
case ',':
 inc lpos
 ltype=#LDELIM
case '0' to '9':
 lfval=float(lext$(func(isnum!)))
 ltype=#LNUM
case 'a' to 'z':
 lsval=lext$(func(isalpha!))
 ltype=#LTOK
 for n=0 to #OPCNT-1
 if opnm[n]=lsval then
 ltype=#LOPER
 lval=n
 endif
 next
case chr&(0):
 ltype=#LEND
case else:
 i=pos(lstr{lpos++},opch)
 if inrange!(i,0,4) then
 ltype=#LOPER
 lval=i
 endif
 if i=5 or i=6 then
 ltype=#LPAREN
 lval = i=5 ? #OPCNT : -#OPCNT
 endif
endcase
if ltype=#LNONE then
error "lex",0
endif
endp

func regfval
for n=0 to fpos-1
if fstk[n]=lfval goto 1
next
n=fpos
fstk[fpos++]=lfval
1
return n


