//---------------------------------------------------------------------------

#ifndef statusdlg_unitH
#define statusdlg_unitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>

enum task_t
{
    TASK_EVAL,
    TASK_DERIVE,
    TASK_TAYLOR,
};

struct cbfuncdata_t
{
    TCustomMemo* MmoOutput;
    TProgressBar* PbrStatus;
    task_t task;
    unsigned priority;
    unsigned max_pr;
    HANDLE hThread;
    bool done;
    double xoffs;
    unsigned degree;
};

//---------------------------------------------------------------------------
class TFrmStatusDlg : public TForm
{
__published:	// Von der IDE verwaltete Komponenten
    TLabel *LblAction;
    TMemo *MmoStatus;
    TButton *BtnCancel;
    TProgressBar *PbrProgress;
    void __fastcall BtnCancelClick(TObject *Sender);
private:	// Anwender-Deklarationen
public:		// Anwender-Deklarationen
    __fastcall TFrmStatusDlg(TComponent* Owner);
    cbfuncdata_t* cbfd;
};
//---------------------------------------------------------------------------
extern PACKAGE TFrmStatusDlg *FrmStatusDlg;
//---------------------------------------------------------------------------
#endif
